$(function(){

    const api_address_url = "//api-adresse.data.gouv.fr/search/";
    
    let address = $('#address').val();
    const inputAddress = $('#address'); 
    const inputTown = $('#town'); 
    const zipcode = $('#zipcode').val();

    const  error_msg_element = $('<p>Recherchez une addresse : </p>')

    const correspondance_addresse = [
        {
            "short": " bd ",
            "long": " boulevard "
        },
        {
            "short": " rpt ",
            "long": " rond-point "
        },
        {
            "short": " pl ",
            "long": " place "
        },
        {
            "short": " av ",
            "long": " avenue "
        },
        {
            "short": " rt ",
            "long": " route "
        },
        {
            "short": " r ",
            "long": " rue "
        },
    ];

    if(address !== "")
    {
        address = address.toLowerCase()
        for(correspondance of correspondance_addresse)
        {
            if(address.includes(correspondance.short))
            {
                address = address.replace(correspondance.short, correspondance.long);
            }
        }

        $.ajax({
            url: `${api_address_url}?q=${address.split(' ').join('+')}&postcode=${zipcode}&limit=1`
        }).fail(function (jqxhr, textStatus, error) {

            $.jnotify(`L'adresse ${address} n'a pas été trouvée`, "error", 'true', { remove: function (){} } );
            inputAddress.css('border', 'solid');	
            inputAddress.css('borderColor', 'red');	
            error_msg_element.insertBefore('#address');
        
            }).done(function (response) {
            // no address found
            if(response.features.length === 0)
            {
                $.jnotify(`L'adresse ${address} n'a pas été trouvée`, "error", 'true', { remove: function (){} } );
                inputAddress.css('border', 'solid');	
                inputAddress.css('borderColor', 'red');	
                error_msg_element.insertBefore('#address');
            }
            else
            {
                error_msg_element.remove();
                inputAddress.css('borderColor', '');	
                // address found - set the address field and click on map button to display location on map
                const address_data = response.features;
                for(add of address_data)
                {
                    if(add.properties.postcode == zipcode)
                    {
                        inputAddress.val(add.properties.name);
                        inputTown.val(add.properties.city);
                    }
                }
                // click to get the location on the map (prospecting map module)
                $('#get_map_location').click();
            }
        });	
    }
});